    
def loadBindingSequences(filename):

    f = open(filename)
    seqdict = {}
    seqname=""
    seq=""
    labels=""
    
    for row in f:
        if row[0] == '>':
            if seqname:
                seqdict[seqname] = (seq,labels)                
            seqname=row.rstrip()[1:]
            seq=""
            labels=""
        elif row[0] == '-' or row[0] == '+':
            labels+=row.rstrip()
        else:
            seq+=row.rstrip()
    if seqname:
        seqdict[seqname] = (seq,labels)

    f.close()
    return seqdict


def extractBindingResidues(seqdict):

    binding=""
    
    for (seq,labels) in seqdict.values():
        for i in range(len(labels)):
            if labels[i] == '+':
                binding += seq[i]
    return binding

def computeHistogram(sequence):

    hist={}
    for r in sequence:
        if not hist.has_key(r):
            hist[r] = 1
        else:
            hist[r] += 1
    return hist


def printHistogram(hist):
    
    print "\n".join([res + "\t" + str(count) for (res,count) in hist.items()])


def bindingResiduesHistogram(bindingfile):

    seqdict = loadBindingSequences(bindingfile)
    binding = extractBindingResidues(seqdict)
    hist = computeHistogram(binding)
    printHistogram(hist)
