    
def loadConservedSequences(filename):

    f = open(filename)

    # header
    f.readline()
    
    consdict = {}
    
    for row in f:
        data = row.split()
        type = data[-1]
        seq = data[-2]
        if not consdict.has_key(type):
            consdict[type] = []
        consdict[type].append(seq)
        
    f.close()
    return consdict


def computeHistogram(seqlist, k):

    hist={}

    for seq in seqlist:
        for i in range(len(seq)-k+1):
            sub=seq[i:i+k]
            if not hist.has_key(sub):
                hist[sub] = 1
            else:
                hist[sub] +=1

    return hist


def stringHistogram(hist):

    return "\n".join([k + "\t" + str(v) for k,v in hist.items()])


def computeHistograms(consdict, k):

    for type,seqs in consdict.items():
        hist = computeHistogram(seqs,k)
        print type
        print stringHistogram(hist)


def UTRConservationHistogram(filename, k):

    consdict = loadConservedSequences(filename)
    computeHistograms(consdict, k)


